﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Management;
using System.Diagnostics;

namespace wmi
{
    public partial class frm_Main : Form
    {
        int nTime = 0;
        int nCount = 0;
        int nTiks = 0;
        ManagementObjectSearcher searcher;
        WqlObjectQuery wqlQuery;
        DataTable dt = new DataTable();

        public frm_Main()
        {
            InitializeComponent();
            LoadSet();
        }

        private void LoadSet()
        {
            dt = CreateTable();
            dgView.DataSource = dt;
            for (int i = 0; i < dt.Columns.Count; i++)
            {
                cmbColumns.Items.Add(dt.Columns[i].ColumnName);
            }
        }

        private void QueryCon()
        {
            if (!chkSpec.Checked)
            {
                SendMarkQuery();
            }
            else
            {
                if (cmbColumns.Text.Length > 0)
                {
                    if (txtVal.Text.Length > 0)
                    {
                        SendMarkQuery(cmbColumns.Text, txtVal.Text);
                    }
                    else
                    {
                        MessageBox.Show("Enter Value!");
                    }
                }
                else
                {
                    MessageBox.Show("Select Column!");
                }
            }
        }

        private void SendMarkQuery()
        {
            wqlQuery = new WqlObjectQuery("SELECT * FROM Win32_PerfFormattedData_W3SVC_WebService");
            searcher = new ManagementObjectSearcher(wqlQuery);

            dt.Rows.Clear();
            foreach (ManagementObject s in searcher.Get())
            {
                DataRow dr = dt.NewRow();
                foreach (PropertyData p in s.Properties)
                {
                    try
                    {
                        dr[p.Name] = p.Value;
                    }
                    catch { /*MessageBox.Show(err.Message); */}
                }
                dt.Rows.Add(dr);
            }
        }

        private void SendMarkQuery(string sColumn, string sVal)
        {
            wqlQuery = new WqlObjectQuery("SELECT * FROM Win32_PerfFormattedData_W3SVC_WebService WHERE " + sColumn + "='" + sVal + "'");
            searcher = new ManagementObjectSearcher(wqlQuery);

            dt.Rows.Clear();
            foreach (ManagementObject s in searcher.Get())
            {
                DataRow dr = dt.NewRow();
                foreach (PropertyData p in s.Properties)
                {
                    try
                    {
                        dr[p.Name] = p.Value;
                    }
                    catch { /*MessageBox.Show(err.Message); */}
                }
                dt.Rows.Add(dr);
            }
        }

        private void tTime_Tick(object sender, EventArgs e)
        {
            if (nCount == nTime)
            {
                QueryCon();
                nCount = 0;
            }
            nCount++;
            nTiks++;
            lblTiks.Text = nTiks.ToString();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            nTime = Convert.ToInt16(txtTime.Text);
            QueryCon();
            tTime.Enabled = true;
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            tTime.Enabled = false;
        }

        private void frm_Main_Resize(object sender, EventArgs e)
        {
            dgView.Size = new Size(this.ClientSize.Width, this.ClientSize.Height - 65);
        }

        private DataTable CreateTable()
        {
            DataTable queryTable = new DataTable("qReturn");
            /*
            DataColumn idColumn = new DataColumn();
            idColumn.DataType = System.Type.GetType("System.Int32");
            idColumn.ColumnName = "id";
            idColumn.AutoIncrement = true;
            queryTable.Columns.Add(idColumn);
            */
            //************************************
            DataColumn col1 = new DataColumn();
            col1.DataType = System.Type.GetType("System.String");
            col1.ColumnName = "CurrentConnections";
            //col.DefaultValue = "CurrentConnections";
            queryTable.Columns.Add(col1);
            //************************************
            DataColumn col2 = new DataColumn();
            col2.DataType = System.Type.GetType("System.String");
            col2.ColumnName = "MaximumAnonymousUsers";
            queryTable.Columns.Add(col2);
            //************************************
            DataColumn col3 = new DataColumn();
            col3.DataType = System.Type.GetType("System.String");
            col3.ColumnName = "MaximumCALcountforauthenticatedusers";
            queryTable.Columns.Add(col3);
            //************************************
            DataColumn col4 = new DataColumn();
            col4.DataType = System.Type.GetType("System.String");
            col4.ColumnName = "MaximumCALcountforSSLconnections";
            queryTable.Columns.Add(col4);
            //************************************
            DataColumn col5 = new DataColumn();
            col5.DataType = System.Type.GetType("System.String");
            col5.ColumnName = "MaximumCGIRequests";
            queryTable.Columns.Add(col5);
            //************************************
            DataColumn col6 = new DataColumn();
            col6.DataType = System.Type.GetType("System.String");
            col6.ColumnName = "MaximumConnections";
            queryTable.Columns.Add(col6);
            //************************************
            DataColumn col7 = new DataColumn();
            col7.DataType = System.Type.GetType("System.String");
            col7.ColumnName = "MaximumISAPIExtensionRequests";
            queryTable.Columns.Add(col7);
            //************************************
            DataColumn col8 = new DataColumn();
            col8.DataType = System.Type.GetType("System.String");
            col8.ColumnName = "Name";
            queryTable.Columns.Add(col8);
            //************************************
            DataColumn col9 = new DataColumn();
            col9.DataType = System.Type.GetType("System.String");
            col9.ColumnName = "TotalAnonymousUsers";
            queryTable.Columns.Add(col9);
            //************************************
            DataColumn col10 = new DataColumn();
            col10.DataType = System.Type.GetType("System.String");
            col10.ColumnName = "TotalBytesReceived";
            queryTable.Columns.Add(col10);
            //************************************
            DataColumn col11 = new DataColumn();
            col11.DataType = System.Type.GetType("System.String");
            col11.ColumnName = "TotalBytesSent";
            queryTable.Columns.Add(col11);
            //************************************
            DataColumn col12 = new DataColumn();
            col12.DataType = System.Type.GetType("System.String");
            col12.ColumnName = "TotalBytesTransfered";
            queryTable.Columns.Add(col12);
            //************************************
            DataColumn col13 = new DataColumn();
            col13.DataType = System.Type.GetType("System.String");
            col13.ColumnName = "TotalCGIRequests";
            queryTable.Columns.Add(col13);
            //************************************
            DataColumn col14 = new DataColumn();
            col14.DataType = System.Type.GetType("System.String");
            col14.ColumnName = "TotalConnectionAttemptsallinstances";
            queryTable.Columns.Add(col14);
            //************************************
            DataColumn col15 = new DataColumn();
            col15.DataType = System.Type.GetType("System.String");
            col15.ColumnName = "TotalCopyRequests";
            queryTable.Columns.Add(col15);
            //************************************
            DataColumn col16 = new DataColumn();
            col16.DataType = System.Type.GetType("System.String");
            col16.ColumnName = "TotalcountoffailedCALrequestsforauthenticatedusers";
            queryTable.Columns.Add(col16);
            //************************************
            DataColumn col17 = new DataColumn();
            col17.DataType = System.Type.GetType("System.String");
            col17.ColumnName = "TotalcountoffailedCALrequestsforSSLconnections";
            queryTable.Columns.Add(col17);
            //************************************
            DataColumn col18 = new DataColumn();
            col18.DataType = System.Type.GetType("System.String");
            col18.ColumnName = "TotalDeleteRequests";
            queryTable.Columns.Add(col18);
            //************************************
            DataColumn col19 = new DataColumn();
            col19.DataType = System.Type.GetType("System.String");
            col19.ColumnName = "TotalFilesReceived";
            queryTable.Columns.Add(col19);
            //************************************
            DataColumn col20 = new DataColumn();
            col20.DataType = System.Type.GetType("System.String");
            col20.ColumnName = "TotalFilesSent";
            queryTable.Columns.Add(col20);
            //************************************
            DataColumn col21 = new DataColumn();
            col21.DataType = System.Type.GetType("System.String");
            col21.ColumnName = "TotalFilesTransferred";
            queryTable.Columns.Add(col21);
            //************************************
            DataColumn col22 = new DataColumn();
            col22.DataType = System.Type.GetType("System.String");
            col22.ColumnName = "TotalGetRequests";
            queryTable.Columns.Add(col22);
            //************************************
            DataColumn col23 = new DataColumn();
            col23.DataType = System.Type.GetType("System.String");
            col23.ColumnName = "TotalHeadRequests";
            queryTable.Columns.Add(col23);
            //************************************
            DataColumn col24 = new DataColumn();
            col24.DataType = System.Type.GetType("System.String");
            col24.ColumnName = "TotalISAPIExtensionRequests";
            queryTable.Columns.Add(col24);
            //************************************
            DataColumn col25 = new DataColumn();
            col25.DataType = System.Type.GetType("System.String");
            col25.ColumnName = "TotalLockedErrors";
            queryTable.Columns.Add(col25);
            //************************************
            DataColumn col26 = new DataColumn();
            col26.DataType = System.Type.GetType("System.String");
            col26.ColumnName = "TotalLockRequests";
            queryTable.Columns.Add(col26);
            //************************************
            DataColumn col27 = new DataColumn();
            col27.DataType = System.Type.GetType("System.String");
            col27.ColumnName = "TotalLogonAttempts";
            queryTable.Columns.Add(col27);
            //************************************
            DataColumn col28 = new DataColumn();
            col28.DataType = System.Type.GetType("System.String");
            col28.ColumnName = "TotalMethodRequests";
            queryTable.Columns.Add(col28);
            //************************************
            DataColumn col29 = new DataColumn();
            col29.DataType = System.Type.GetType("System.String");
            col29.ColumnName = "TotalMethodRequestsPersec";
            queryTable.Columns.Add(col29);
            //************************************
            DataColumn col30 = new DataColumn();
            col30.DataType = System.Type.GetType("System.String");
            col30.ColumnName = "TotalMkcolRequests";
            queryTable.Columns.Add(col30);
            //************************************
            DataColumn col31 = new DataColumn();
            col31.DataType = System.Type.GetType("System.String");
            col31.ColumnName = "TotalMoveRequests";
            queryTable.Columns.Add(col31);
            //************************************
            DataColumn col32 = new DataColumn();
            col32.DataType = System.Type.GetType("System.String");
            col32.ColumnName = "TotalNonAnonymousUsers";
            queryTable.Columns.Add(col32);
            //************************************
            DataColumn col33 = new DataColumn();
            col33.DataType = System.Type.GetType("System.String");
            col33.ColumnName = "TotalNotFoundErrors";
            queryTable.Columns.Add(col33);
            //************************************
            DataColumn col34 = new DataColumn();
            col34.DataType = System.Type.GetType("System.String");
            col34.ColumnName = "TotalOptionsRequests";
            queryTable.Columns.Add(col34);
            //************************************
            DataColumn col35 = new DataColumn();
            col35.DataType = System.Type.GetType("System.String");
            col35.ColumnName = "TotalOtherRequestMethods";
            queryTable.Columns.Add(col35);
            //************************************
            DataColumn col36 = new DataColumn();
            col36.DataType = System.Type.GetType("System.String");
            col36.ColumnName = "TotalPostRequests";
            queryTable.Columns.Add(col36);
            //************************************
            DataColumn col37 = new DataColumn();
            col37.DataType = System.Type.GetType("System.String");
            col37.ColumnName = "TotalPropfindRequests";
            queryTable.Columns.Add(col37);
            //************************************
            DataColumn col38 = new DataColumn();
            col38.DataType = System.Type.GetType("System.String");
            col38.ColumnName = "TotalProppatchRequests";
            queryTable.Columns.Add(col38);
            //************************************
            DataColumn col39 = new DataColumn();
            col39.DataType = System.Type.GetType("System.String");
            col39.ColumnName = "TotalPutRequests";
            queryTable.Columns.Add(col39);
            //************************************
            DataColumn col40 = new DataColumn();
            col40.DataType = System.Type.GetType("System.String");
            col40.ColumnName = "TotalRejectedAsyncIORequests";
            queryTable.Columns.Add(col40);
            //************************************
            DataColumn col41 = new DataColumn();
            col41.DataType = System.Type.GetType("System.String");
            col41.ColumnName = "TotalSearchRequests";
            queryTable.Columns.Add(col41);
            //************************************
            DataColumn col42 = new DataColumn();
            col42.DataType = System.Type.GetType("System.String");
            col42.ColumnName = "TotalTraceRequests";
            queryTable.Columns.Add(col42);
            //************************************
            DataColumn col43 = new DataColumn();
            col43.DataType = System.Type.GetType("System.String");
            col43.ColumnName = "TotalUnlockRequests";
            queryTable.Columns.Add(col43);
            //************************************
            DataColumn col44 = new DataColumn();
            col44.DataType = System.Type.GetType("System.String");
            col44.ColumnName = "TraceRequestsPersec";
            queryTable.Columns.Add(col44);
            //************************************
            DataColumn col45 = new DataColumn();
            col45.DataType = System.Type.GetType("System.String");
            col45.ColumnName = "UnlockRequestsPersec";
            queryTable.Columns.Add(col45);

            /*
            DataColumn[] keys = new DataColumn[1];
            keys[0] = idColumn;
            queryTable.PrimaryKey = keys;
            */
            return queryTable;
        }
    }
}

